/**********************************************************************

	--- Qt Architect generated file ---

	File: wintvcsan.cpp
	Last generated: Sat Dec 19 18:13:19 1998

 *********************************************************************/

#include "wintvcsan.h"

#ifdef myDEBUG
#define scanDEBUG
#endif

#define Inherited wintvcsandata

winTVcsan::winTVcsan
(
	QWidget* parent,
	const char* name,
	rcfile *_rc,
	struct video_capability* _vcap,
	struct video_channel* _vchan,
	struct video_tuner* _vtuner,
	struct video_audio* _vaudio,
	winTVScreenWidget *_winTVScreenPtr
)
	:
	Inherited( parent, name ),
	rc(_rc),winTVScreenPtr(_winTVScreenPtr),
	vcap(_vcap),vchan(_vchan),vtuner(_vtuner),vaudio(_vaudio)
{
  setCaption( "Scan all Channels for Programs" );
  
  aktivecntry.change(rc->country_id);
  rc->country_name=QString(chan_names[rc->country_id].str);

  int i,aktive=0;
  for (i=0; i <= KNOWN_COUNTRIES; i++) {
    cntry->insertItem(chan_names[i].str,i);
  }
  cntry->setCurrentItem(rc->country_id);

  for (i = 0; norms[i].str != NULL; i++) 
    if (vtuner->flags & (1<<i)) {
      snorm->insertItem(norms[i].str,i);
      if (vtuner->mode == i) aktive=i;
    }
  snorm->setCurrentItem(aktive);
  norm=aktive;

  for (i = 0; i < vcap->channels; i++) {
    if ( vchan[i].tuners ) {
      sinput->insertItem(vchan[i].name,i);
    }
  }
  input=0;


  progressview = new QProgressBar(this,NULL);
  progressview->setGeometry( progressframe->geometry() );
  progressview->setTotalSteps(aktivecntry.nftab());

  clistview = new QListView(this,NULL);
  clistview->setGeometry( viewframe->geometry() );
  {
    QFont font( "helvetica", 14, 20, 0 ); // 63
    font.setStyleHint( (QFont::StyleHint)0 );
    font.setCharSet( (QFont::CharSet)0 );
    clistview->setFont( font );
  }
  clistview->setFrameStyle( 51 );
  clistview->setLineWidth( 2 );
  clistview->setMultiSelection ( false );
  clistview->setAllColumnsShowFocus( true );
  clistview->setTreeStepSize( 0 ); 
  clistview->setRootIsDecorated( false );
  //clistview->setSorting( 0 , true );
  //clistview->setSorting( 1 , true );
  //clistview->setColumnAlignment ( 0, 2 ) ;

  clistview->addColumn("Nr.");
  clistview->addColumn("Ch.");
  clistview->addColumn("Name");
  
  cname=(char *)malloc(255);
  runScan=false;
}
winTVcsan::~winTVcsan()
{
  delete clistview;
  free(cname);
}
void winTVcsan::setDataSLOT(QList<channel> *clist)
{
  cancelbutton->setEnabled(true);
  okbutton->setEnabled(true);
  scanbutton->setText("Scan ...");

  if (!clist->isEmpty()) {
    channel_list = *clist;

    channel *ch = channel_list.first();
    
    int nid= 1;
    
    while ( ch ) {
      QString id;
      id.sprintf("%2d",nid++);

      QListViewItem *lvi= new QListViewItem( clistview, 
					     (const char*)id, "", ch->name );
      clistview->ensureItemVisible(lvi);
      ch= channel_list.next();
    }
  }
}

void winTVcsan::newInputSLOT(int id)
{
  input=id;
  emit inputChangedSIGNAL(id);
}
void winTVcsan::newNormSLOT(int id)
{
  norm=id;
  emit normChangedSIGNAL(id);
}
void winTVcsan::newCountrySLOT(int id)
{
  aktivecntry.change(id);
  progressview->setTotalSteps(aktivecntry.nftab());
}
void winTVcsan::scanbuttonSLOT()
{
  if ( !runScan ) {
    frequency=aktivecntry.firstchan(cname);
    emit frequencyChangedSIGNAL(frequency);
    
    fchan= aktivecntry.activeindex();
    cancelbutton->setEnabled(false);
    okbutton->setEnabled(false);
    scanbutton->setText("Stop Scan");
    index=channel_list.count();
    runScan= true;
    runScanSLOT();
  } else {
    cancelbutton->setEnabled(true);
    okbutton->setEnabled(true);
    runScan=false;
    scanbutton->setText("Scan ...");
  }
}

void winTVcsan::runScanSLOT()
{
  if ( runScan ) {
#ifdef scanDEBUG
  debug("scan: running");
#endif
    QTimer::singleShot( TIMEWAIT, this, SLOT(checkScanSLOT()) );
  }
}
void winTVcsan::checkScanSLOT()
{
  long quality = winTVScreenPtr->getChannelSignal();
#ifdef scanDEBUG
  debug("scan: checking channel %s",cname);
#endif
  if ( (quality > SIGQUALITY) ) {
    
    // add channel to list
    QString id;
    id.sprintf("%2d",++index);

    QString ch;
    ch.sprintf("%s",cname);

    QString name;
    name.sprintf("prog_%d",aktivecntry.activeindex());

#ifdef scanDEBUG
  debug("scan: adding %s, %s, %s",(const char*)id, (const char*)ch, (const char*)name );
#endif
    QListViewItem *lvi= new QListViewItem( clistview, 
					   (const char*)id, (const char*)ch, (const char*)name );
    
    channel *s=new channel(frequency,(const char*)name,
			   rc->col,rc->bri,rc->hue,rc->contr,norm,input);
    channel_list.append(s);

    clistview->setCurrentItem(lvi);
    clistview->ensureItemVisible(lvi);

    progressview->setProgress(aktivecntry.activeindex());
    frequency=aktivecntry.nextchan(cname);
    if (fchan == aktivecntry.activeindex()) {
      // we are done
      runScan=false;
      cancelbutton->setEnabled(true);
      okbutton->setEnabled(true);
      scanbutton->setText("Scan ...");
      //emit readyScanChannelsSIGNAL(1);
    }
    emit frequencyChangedSIGNAL(frequency);
    runScanSLOT();

  } else {
    progressview->setProgress(aktivecntry.activeindex());
    frequency=aktivecntry.nextchan(cname);
    if (fchan == aktivecntry.activeindex()) {
      // we are done
      runScan=false;
      cancelbutton->setEnabled(true);
      okbutton->setEnabled(true);
      scanbutton->setText("Scan ...");
      //emit readyScanChannelsSIGNAL(1);
    }
    emit frequencyChangedSIGNAL(frequency);
    runScanSLOT();
  }
}

void winTVcsan::cancelbuttonSLOT()
{
  runScan=false;
  emit readyScanChannelsSIGNAL(0);
}
void winTVcsan::okbuttonSLOT()
{
  runScan=false;
  emit readyScanChannelsSIGNAL(1);
}
#include "wintvcsan.moc"
